\ 3iMotor.fs - 2020-10-11---Sun---14:51

\ Hardware:
\ 28BYJ-48 5V DC Step Motor, 5.625* step angle, 4 phase motor, 8 signals goes through all 4 phases
\ ULN2003A-PCB motor driver PCB

\ Connections:
\ ports 5 4 3 2 out from Nano to ULN board (2 to IN1)
\ motor to ULN board --- blue to top (aligned with IN1), red at bottom (power)
\ WARNING: power the ULN board separately with 5V from DC volt
\ jumper pin powers the board or cuts power to it -- use a relay to cut power to the motors (they will draw power ambiently)

\ Dec 25, 2018 - 9V to 5V DC converter producing 5V TTL output to 4-button manual step motor driver

: motor-init  5 4 3 2 port4out ;
: test-port4  16 0 do i port4write 250 ms loop 0 port4write ;
create spincode 1 c, 3 c, 2 c, 6 c, 4 c, 12 c, 8 c, 9 c, 
spincode 7 + constant -spincode
: spin spincode 8 0 do c@+ port4write loop drop ;
: -spin -spincode 8 0 do c@- port4write loop drop ;
: spinN ( N -- ) dup 0> if 0 do spin loop else negate 0 do -spin loop then ;  \ 512 steps for a full revolution ( =64 * 8


\ NEXT STEP:
\ Why does motor get hot?  How to cool it?
\ To go faster, incorporate the spinN code in the AVR
\ Add relay to cut power
\ Measure power consumption
\ Do I really need the ULN PCB, why not just the chip?
\ What about TIP122 transistor, would I need 4 therefore?
\ Why 512 steps in a revolution?  
